Loading...
Searching...
No Matches
itk::NDImageTemplate< TPixel, VDimension > Class Template Reference
Common » Miscellaneous

`#include <itkNDImageTemplate.h>`

## Detailed Description

template<class TPixel, unsigned int VDimension>
class itk::NDImageTemplate< TPixel, VDimension >

This class is a specialization of the NDImageBase, which acts as a wrap around an itk::Image.

The NDImageTemplate class is a kind of wrap around the itk::Image. It has an itk::Image object as an internal member variable. Most functions simply call the the corresponding function in the itk::Object. For some functions, the in/output arguments have to be converted from/to arrays with runtime length to/from arrays with compile time length.

See also
  NDImageBase

Definition at line 45 of file itkNDImageTemplate.h.

Inheritance diagram for itk::NDImageTemplate< TPixel, VDimension >:
[legend]

## Data Structures

class | ConvertToDynamicArray
class | ConvertToStaticArray

## Public Types

using | AccessorType
using | ConstPointer = SmartPointer<const Self>
using | DataObjectPointer
using | ImagePointer = typename ImageType::Pointer
using | ImageType = Image<TPixel, VDimension>
using | IndexType
using | IndexTypeD = typename ImageType::IndexType
using | InternalPixelType
using | OffsetType
using | OffsetTypeD = typename ImageType::OffsetType
using | OffsetValueType
using | PixelContainer
using | PixelContainerConstPointer
using | PixelContainerPointer
using | Pointer = SmartPointer<Self>
using | PointType
using | PointTypeD = typename ImageType::PointType
using | PointValueType
using | ReaderPointer = typename ReaderType::Pointer
using | ReaderType = ImageFileReader<ImageType>
using | Self = NDImageTemplate
using | SizeType
using | SizeTypeD = typename ImageType::SizeType
using | SpacingType
using | SpacingTypeD = typename ImageType::SpacingType
using | SpacingValueType
using | Superclass = NDImageBase<TPixel>
using | ValueType
using | WriterPointer = typename WriterType::Pointer
using | WriterType = ImageFileWriter<ImageType>
Public Types inherited from itk::NDImageBase< TPixel >
using | AccessorType = typename Image<TPixel, 2>::AccessorType
using | ConstPointer = SmartPointer<const Self>
using | DataObjectPointer = DataObject::Pointer
using | IndexType = Array<IndexValueType>
using | InternalPixelType = typename Image<TPixel, 2>::InternalPixelType
using | OffsetType = Array<OffsetValueType>
using | OffsetValueType = typename ImageBase<2>::OffsetValueType
using | PixelContainer = typename Image<TPixel, 2>::PixelContainer
using | PixelContainerConstPointer = typename Image<TPixel, 2>::PixelContainerConstPointer
using | PixelContainerPointer = typename Image<TPixel, 2>::PixelContainerPointer
using | Point2DType = typename ImageBase<2>::PointType
using | Pointer = SmartPointer<Self>
using | PointType = Array<PointValueType>
using | PointValueType = typename Point2DType::ValueType
using | Self = NDImageBase
using | SizeType = Array<SizeValueType>
using | Spacing2DType = typename ImageBase<2>::SpacingType
using | SpacingType = Array<SpacingValueType>
using | SpacingValueType = typename Spacing2DType::ValueType
using | Superclass = Object
using | ValueType = typename Image<TPixel, 2>::ValueType

## Public Member Functions

void | Allocate () override
IndexType | ComputeIndex (OffsetValueType offset) const override
OffsetValueType | ComputeOffset (const IndexType &ind) const override
void | CopyInformation (const DataObject *data) override
void | CreateNewImage () override
void | FillBuffer (const TPixel &value) override
const TPixel * | GetBufferPointer () const override
TPixel * | GetBufferPointer () override
virtual const char * | GetClassName () const
unsigned int | GetImageDimension () override
ImageIOBase * | GetImageIOReader () override
ImageIOBase * | GetImageIOWriter () override
const char * | GetInputFileName () override
const OffsetValueType * | GetOffsetTable () const override
PointType | GetOrigin () override
const char * | GetOutputFileName () override
const TPixel & | GetPixel (const IndexType &index) const override
TPixel & | GetPixel (const IndexType &index) override
const AccessorType | GetPixelAccessor () const override
AccessorType | GetPixelAccessor () override
const PixelContainer * | GetPixelContainer () const override
PixelContainer * | GetPixelContainer () override
SpacingType | GetSpacing () override
unsigned int | ImageDimension () override
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (NDImageTemplate)
| itkGetModifiableObjectMacro (Image, DataObject)
| itkGetModifiableObjectMacro (Reader, ProcessObject)
| itkGetModifiableObjectMacro (Writer, ProcessObject)
| itkStaticConstMacro (Dimension, unsigned int, VDimension)
void | Read () override
void | SetImageIOReader (ImageIOBase *_arg) override
void | SetImageIOWriter (ImageIOBase *_arg) override
void | SetInputFileName (const char *name) override
void | SetOrigin (const PointType &origin) override
void | SetOutputFileName (const char *name) override
void | SetPixel (const IndexType &index, const TPixel &value) override
void | SetPixelContainer (PixelContainer *container) override
void | SetRegions (SizeType size) override
void | SetRequestedRegion (DataObject *data) override
void | SetSpacing (const SpacingType &spacing) override
void | Write () override
Public Member Functions inherited from itk::NDImageBase< TPixel >
| ITK_DISALLOW_COPY_AND_MOVE (NDImageBase)
TPixel & | operator[] (const IndexType &index)
const TPixel & | operator[] (const IndexType &index) const

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::NDImageBase< TPixel >
static Pointer | NewNDImage (unsigned int dim)

## Protected Member Functions

| NDImageTemplate ()=default
| ~NDImageTemplate () override=default
Protected Member Functions inherited from itk::NDImageBase< TPixel >
| NDImageBase ()=default
| ~NDImageBase () override=default

## Protected Attributes

ImagePointer | m_Image { nullptr }
ReaderPointer | m_Reader { nullptr }
WriterPointer | m_Writer { nullptr }

## Member Typedef Documentation

## AccessorType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::AccessorType

Definition at line 83 of file itkNDImageBase.h.

## ConstPointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::ConstPointer = SmartPointer<const Self>

Definition at line 54 of file itkNDImageTemplate.h.

## DataObjectPointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::DataObjectPointer

Definition at line 77 of file itkNDImageBase.h.

## ImagePointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::ImagePointer = typename ImageType::Pointer

Definition at line 92 of file itkNDImageTemplate.h.

## ImageType

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::ImageType = Image<TPixel, VDimension>

Typedefs dependent on the dimension

Definition at line 91 of file itkNDImageTemplate.h.

## IndexType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::IndexType

ND versions of the index and sizetypes. Unlike in their counterparts in the itk::Image, their size can be defined at runtime. The elx::NDImageTemplate takes care of converting from/to these types to to/from the corresponding types in itk::Image.

Definition at line 100 of file itkNDImageBase.h.

## IndexTypeD

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::IndexTypeD = typename ImageType::IndexType

Original, itk, versions of the index and sizetypes etc.

Definition at line 99 of file itkNDImageTemplate.h.

## InternalPixelType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::InternalPixelType

Definition at line 82 of file itkNDImageBase.h.

## OffsetType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::OffsetType

Definition at line 104 of file itkNDImageBase.h.

## OffsetTypeD

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::OffsetTypeD = typename ImageType::OffsetType

Definition at line 103 of file itkNDImageTemplate.h.

## OffsetValueType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::OffsetValueType

Definition at line 93 of file itkNDImageBase.h.

## PixelContainer

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::PixelContainer

Definition at line 84 of file itkNDImageBase.h.

## PixelContainerConstPointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::PixelContainerConstPointer

Definition at line 86 of file itkNDImageBase.h.

## PixelContainerPointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::PixelContainerPointer

Definition at line 85 of file itkNDImageBase.h.

## Pointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::Pointer = SmartPointer<Self>

Definition at line 53 of file itkNDImageTemplate.h.

## PointType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::PointType

Definition at line 103 of file itkNDImageBase.h.

## PointTypeD

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::PointTypeD = typename ImageType::PointType

Definition at line 102 of file itkNDImageTemplate.h.

## PointValueType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::PointValueType

Definition at line 92 of file itkNDImageBase.h.

## ReaderPointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::ReaderPointer = typename ReaderType::Pointer

Definition at line 96 of file itkNDImageTemplate.h.

## ReaderType

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::ReaderType = ImageFileReader<ImageType>

Definition at line 95 of file itkNDImageTemplate.h.

## Self

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::Self = NDImageTemplate

Standard class typedefs.

Definition at line 51 of file itkNDImageTemplate.h.

## SizeType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::SizeType

Definition at line 101 of file itkNDImageBase.h.

## SizeTypeD

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::SizeTypeD = typename ImageType::SizeType

Definition at line 100 of file itkNDImageTemplate.h.

## SpacingType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::SpacingType

Definition at line 102 of file itkNDImageBase.h.

## SpacingTypeD

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::SpacingTypeD = typename ImageType::SpacingType

Definition at line 101 of file itkNDImageTemplate.h.

## SpacingValueType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::SpacingValueType

Definition at line 91 of file itkNDImageBase.h.

## Superclass

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::Superclass = NDImageBase<TPixel>

Definition at line 52 of file itkNDImageTemplate.h.

## ValueType

template<class TPixel, unsigned int VDimension>

using itk::NDImageBase< TPixel >::ValueType

Definition at line 81 of file itkNDImageBase.h.

## WriterPointer

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::WriterPointer = typename WriterType::Pointer

Definition at line 94 of file itkNDImageTemplate.h.

## WriterType

template<class TPixel, unsigned int VDimension>

using itk::NDImageTemplate< TPixel, VDimension >::WriterType = ImageFileWriter<ImageType>

Definition at line 93 of file itkNDImageTemplate.h.

## Constructor & Destructor Documentation

## NDImageTemplate()

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::NDImageTemplate | ( |  | ) |

protected default

## ~NDImageTemplate()

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::~NDImageTemplate | ( |  | ) |

override protected default

## Member Function Documentation

## Allocate()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::Allocate | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## ComputeIndex()

template<class TPixel, unsigned int VDimension>

IndexType itk::NDImageTemplate< TPixel, VDimension >::ComputeIndex | ( | OffsetValueType | offset | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## ComputeOffset()

template<class TPixel, unsigned int VDimension>

OffsetValueType itk::NDImageTemplate< TPixel, VDimension >::ComputeOffset | ( | const IndexType & | ind | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## CopyInformation()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::CopyInformation | ( | const DataObject * | data | ) |

override virtual

Todo
  Transform IndexToPoint methods.

Implements itk::NDImageBase< TPixel >.

## CreateNewImage()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::CreateNewImage | ( |  | ) |

override virtual

Use New method to create a new actual image

Implements itk::NDImageBase< TPixel >.

## FillBuffer()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::FillBuffer | ( | const TPixel & | value | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetBufferPointer() [1/2]

template<class TPixel, unsigned int VDimension>

const TPixel * itk::NDImageTemplate< TPixel, VDimension >::GetBufferPointer | ( |  | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## GetBufferPointer() [2/2]

template<class TPixel, unsigned int VDimension>

TPixel * itk::NDImageTemplate< TPixel, VDimension >::GetBufferPointer | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetClassName()

template<class TPixel, unsigned int VDimension>

virtual const char * itk::NDImageTemplate< TPixel, VDimension >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::NDImageBase< TPixel >.

## GetImageDimension()

template<class TPixel, unsigned int VDimension>

unsigned int itk::NDImageTemplate< TPixel, VDimension >::GetImageDimension | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetImageIOReader()

template<class TPixel, unsigned int VDimension>

ImageIOBase * itk::NDImageTemplate< TPixel, VDimension >::GetImageIOReader | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetImageIOWriter()

template<class TPixel, unsigned int VDimension>

ImageIOBase * itk::NDImageTemplate< TPixel, VDimension >::GetImageIOWriter | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetInputFileName()

template<class TPixel, unsigned int VDimension>

const char * itk::NDImageTemplate< TPixel, VDimension >::GetInputFileName | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetOffsetTable()

template<class TPixel, unsigned int VDimension>

const OffsetValueType * itk::NDImageTemplate< TPixel, VDimension >::GetOffsetTable | ( |  | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## GetOrigin()

template<class TPixel, unsigned int VDimension>

PointType itk::NDImageTemplate< TPixel, VDimension >::GetOrigin | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetOutputFileName()

template<class TPixel, unsigned int VDimension>

const char * itk::NDImageTemplate< TPixel, VDimension >::GetOutputFileName | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetPixel() [1/2]

template<class TPixel, unsigned int VDimension>

const TPixel & itk::NDImageTemplate< TPixel, VDimension >::GetPixel | ( | const IndexType & | index | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## GetPixel() [2/2]

template<class TPixel, unsigned int VDimension>

TPixel & itk::NDImageTemplate< TPixel, VDimension >::GetPixel | ( | const IndexType & | index | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetPixelAccessor() [1/2]

template<class TPixel, unsigned int VDimension>

const AccessorType itk::NDImageTemplate< TPixel, VDimension >::GetPixelAccessor | ( |  | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## GetPixelAccessor() [2/2]

template<class TPixel, unsigned int VDimension>

AccessorType itk::NDImageTemplate< TPixel, VDimension >::GetPixelAccessor | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetPixelContainer() [1/2]

template<class TPixel, unsigned int VDimension>

const PixelContainer * itk::NDImageTemplate< TPixel, VDimension >::GetPixelContainer | ( |  | ) | const

override virtual

Implements itk::NDImageBase< TPixel >.

## GetPixelContainer() [2/2]

template<class TPixel, unsigned int VDimension>

PixelContainer * itk::NDImageTemplate< TPixel, VDimension >::GetPixelContainer | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## GetSpacing()

template<class TPixel, unsigned int VDimension>

SpacingType itk::NDImageTemplate< TPixel, VDimension >::GetSpacing | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## ImageDimension()

template<class TPixel, unsigned int VDimension>

unsigned int itk::NDImageTemplate< TPixel, VDimension >::ImageDimension | ( |  | ) |

override virtual

Extra functions for NDImage. Get the Dimension.

Implements itk::NDImageBase< TPixel >.

## Initialize()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::Initialize | ( |  | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::ITK_DISALLOW_COPY_AND_MOVE | ( | NDImageTemplate< TPixel, VDimension > |  | ) |

## itkGetModifiableObjectMacro() [1/3]

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::itkGetModifiableObjectMacro | ( | Image | ,
|  | DataObject | )

Get the actual image

## itkGetModifiableObjectMacro() [2/3]

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::itkGetModifiableObjectMacro | ( | Reader | ,
|  | ProcessObject | )

## itkGetModifiableObjectMacro() [3/3]

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::itkGetModifiableObjectMacro | ( | Writer | ,
|  | ProcessObject | )

## itkStaticConstMacro()

template<class TPixel, unsigned int VDimension>

itk::NDImageTemplate< TPixel, VDimension >::itkStaticConstMacro | ( | Dimension | ,
|  | unsigned int | ,
|  | VDimension | )

Typedefs inherited from Superclass.

## New()

template<class TPixel, unsigned int VDimension>

Pointer itk::NDImageTemplate< TPixel, VDimension >::New | ( |  | ) |

static

Method for creation through the object factory.

## Read()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::Read | ( |  | ) |

override virtual

Read image data from file into the actual image

Implements itk::NDImageBase< TPixel >.

## SetImageIOReader()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetImageIOReader | ( | ImageIOBase * | _arg | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetImageIOWriter()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetImageIOWriter | ( | ImageIOBase * | _arg | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetInputFileName()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetInputFileName | ( | const char * | name | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetOrigin()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetOrigin | ( | const PointType & | origin | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetOutputFileName()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetOutputFileName | ( | const char * | name | ) |

override virtual

Set/Get the Output/Input FileName

Implements itk::NDImageBase< TPixel >.

## SetPixel()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetPixel | ( | const IndexType & | index,
|  | const TPixel & | value )

override virtual

Implements itk::NDImageBase< TPixel >.

## SetPixelContainer()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetPixelContainer | ( | PixelContainer * | container | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetRegions()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetRegions | ( | SizeType | size | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetRequestedRegion()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetRequestedRegion | ( | DataObject * | data | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## SetSpacing()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::SetSpacing | ( | const SpacingType & | spacing | ) |

override virtual

Implements itk::NDImageBase< TPixel >.

## Write()

template<class TPixel, unsigned int VDimension>

void itk::NDImageTemplate< TPixel, VDimension >::Write | ( |  | ) |

override virtual

Write the actual image to file.

Implements itk::NDImageBase< TPixel >.

## Field Documentation

## m_Image

template<class TPixel, unsigned int VDimension>

ImagePointer itk::NDImageTemplate< TPixel, VDimension >::m_Image { nullptr }

protected

Definition at line 233 of file itkNDImageTemplate.h.

## m_Reader

template<class TPixel, unsigned int VDimension>

ReaderPointer itk::NDImageTemplate< TPixel, VDimension >::m_Reader { nullptr }

protected

Definition at line 235 of file itkNDImageTemplate.h.

## m_Writer

template<class TPixel, unsigned int VDimension>

WriterPointer itk::NDImageTemplate< TPixel, VDimension >::m_Writer { nullptr }

protected

Definition at line 234 of file itkNDImageTemplate.h.

Generated on 1768596610 for elastix by 1.15.0 |